BPC API
In most cases, a logged-in user or an API key is required to access the BPC API. The latter is recommended. Please also note the required role or permission in each case.
Audit Log API
These are the endpoints of the audit log service.
| Method | Endpoint | |||||||||
|---|---|---|---|---|---|---|---|---|---|---|
|
||||||||||
Description To create a new audit log entry, send a JSON message with the following structure:
Note: 'externalReference' is optional and must be a JSON object when used. For calls from IGUASU, the following HTTP headers are used, and their values are written to the following 'externalReference' object fields:
|
||||||||||
Returns HTTP Status Code
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Redirects the user to the monitor using the audit log OpenSearch index. All provided query parameters are used to build a monitor filter on fields of the 'externalReference' object. For IGUASU, the following query parameters can be used to access the HTTP header values from when the entry was created.
|
||||||||||
Returns The requested data as JSON. HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights Can be used without a user session. |
Authentication API
These are the authentication endpoints.
| Method | Endpoint |
|---|---|
|
|
Description Check if the user session is valid. This function checks for the presence of an ssoToken. If a token is found, it is verified with the identity provider. If no token is found or the verification fails, a 401 "UNAUTHORIZED" response will be returned. If the token is confirmed by the provider, a 200 OK response will be sent. |
|
Returns The user session as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Terminates the current user session. |
|
Returns HTTP Status Code
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Destroy all user sessions. |
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Destroys a specific user session. |
|
Path Parameter
|
|
Returns HTTP status code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Form-based login. Credentials are forwarded to the identity provider. If the login is successful, the ssoToken is set as a cookie in the response, and the information from provider is returned as JSON. |
|
Consumes
|
|
Returns The user session as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Form-based update of an existing session with the given tenant name. |
|
Consumes
|
|
Form Parameter
|
|
Returns The user session as JSON. HTTP status code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Set the provided language in the user session. When Keycloak is used as an IdP, the language is set in the Keycloak user profile (locale). |
|
Path Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Forwards the provided body to the user self-service portal of the currently used identity provider. |
|
Consumes
|
|
Returns The response from the user self-service HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Form-based update of the user’s password. If the IdP does not support updating user passwords, the user self-service is used. Form parameters to provide:
|
|
Consumes
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Impersonate a user. Works only when Keycloak is used as the identity provider. |
|
Path Parameter
|
|
Returns The user session as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get user info using an access token. Can only be used with an OpenID Connect provider. CURL example using 'bearer' as the access token type
|
|
Consumes
|
|
Path Parameter
|
|
Form Parameter
|
|
Returns The requested user info as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
BOM API
These are the BOM endpoints.
BOM stands for Bill of Materials and is an aggregation of all software dependencies that the BPC modules/bundles have.
To be listed, the modules/bundles must place their BOM in the file /META-INF/bom.json.
| Method | Endpoint |
|---|---|
|
|
Description Forces a reload of the BOMs. |
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get the BOMs of all BPC bundles. |
|
Returns The requested BOMs. Example response:
HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get only the symbolic names of BPC bundles with BOMs. |
|
Returns The requested list. Example response:
HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get the BOM of a specific BPC bundle by its symbolic name. |
|
Path Parameter
|
|
Returns The content of the HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Download the BOM of a specific BPC bundle by its symbolic name. |
|
Path Parameter
|
|
Returns The content of the HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
Backups API
These are the backup endpoints.
| Method | Endpoint |
|---|---|
|
|
Description Get a list of all backups/snapshots as JSON. |
|
Returns The requested data as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Creates a backup/snapshot of the BPC configuration index |
|
Returns The backup/snapshot information as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Creates a backup/snapshot of the indexes related to a backup job. |
|
Path Parameter
|
|
Returns The backup/snapshot information as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get the data of a specific backup/snapshot. |
|
Path Parameter
|
|
Returns The requested backup/snapshot data as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Delete a specific backup/snapshot. |
|
Path Parameter
|
|
Returns The information about the deleted backup/snapshot as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Restores and activates a specific backup/snapshot. |
|
Path Parameter
|
|
Returns Some information about the restored and activated backup/snapshot as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Restores but does not activate a specific backup/snapshot. |
|
Path Parameter
|
|
Query Parameter
|
|
Returns Some information about the restored backup/snapshot as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Download the contents of a backup/snapshot. |
|
Path Parameter
|
|
Returns The requested data as JSON. Uses the HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Export the content of a |
|
Path Parameter
|
|
Returns The requested data as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
Configuration API
These are the configuration endpoints.
| Method | Endpoint |
|---|---|
|
|
Description Get a complete version of the BPC configuration. It will contain all modules, instances, and their settings, but restricted to the user’s permissions. Each module provides its own default configuration and that of its instances. Additionally, some metadata—such as the model version and information about the
|
|
Returns The requested data as JSON HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get a compact version of the BPC configuration. It will contain all modules, instances, and their settings, but restricted to the user’s access rights.
It will return only those settings where the ` Additionally, metadata about the model version is provided.
|
|
Returns The requested data as JSON HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get the base BPC configuration to initialize the frontend. |
|
Returns The requested data as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Generates unique IDs using "SHA-256". The result is a 256-bit UUID as a HEX string. |
|
Query Parameter
|
|
Returns The requested UUIDs as a JSON array. HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Generates a unique API key using "SHA-256" (256-bit UUID as a HEX string) and the API key ID. example response
|
|
Returns The requested data as a JSON object. HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get a new instance ID for the provided module and module type. |
|
Path Parameters
|
|
Returns The requested data as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get the configuration of a specific module. The result contains the module’s settings, but is restricted to the user’s permissions. Additionally, the default configuration for the module itself and for instances is provided. Contains a compact list of instances with their ID, type, and name if the module is instantiable.
|
|
Path Parameter
|
|
Returns The requested data as JSON HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get the configuration of a specific module instance. If the configuration of an instance is requested, only the settings for which the user has access rights are returned.
If the configuration of a module is requested, it returns the same results as the endpoint without the |
|
Path Parameter
|
|
Returns The requested data as JSON HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Set the module configuration provided in the body. |
|
Consumes
|
|
Path Parameter
|
|
Query Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Set the module instance configuration provided in the body. |
|
Consumes
|
|
Path Parameter
|
|
Query Parameters
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Delete a single setting from a module instance. If this instance has a default value for this setting, the default will be restored. |
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Delete a list of settings (provided in the body) from a module instance. |
|
Consumes
|
|
Path Parameters
|
|
Returns HTTP status code
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Delete a specific module instance. |
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Performs a connection test on a specific module instance. Additional data to be processed can be provided in the POST body as a JSON object. |
|
Consumes
|
|
Path Parameters
|
|
Returns The error result as JSON; returns nothing if successful HTTP status code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get the JSON schema to validate a JSON-based module setting. |
|
Path Parameter
|
|
Returns The requested data as JSON HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get the JSON schema to validate a JSON-based module instance setting. |
|
Path Parameter
|
|
Returns The requested data as JSON HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
Configuration File API
These are the endpoints to set properties in the BPC-related Karaf properties file: etc/de.virtimo.bpc.core.cfg
| Method | Endpoint |
|---|---|
|
|
Description Sets a property in the local BPC-related Karaf properties file: Required Role and Right:
|
|
Path Parameter
|
|
Query Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Sets a property in the remote BPC-related Karaf properties file: |
|
Path Parameter
|
|
Query Parameter
|
|
Returns The response from the remote BPC. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
Data Lock API
These are the data lock endpoints, which are closely tied to OpenSearch (responses). Please try using the storage endpoints instead.
| Method | Endpoint |
|---|---|
|
|
Description Get data lock items from the OpenSearch index |
|
Query Parameters
|
|
Returns The requested items as JSON (1:1 OpenSearch response) HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get a specific data lock item from the OpenSearch index |
|
Path Parameter
|
|
Returns The requested item as JSON (1:1 OpenSearch response) HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Sets the provided data for a specific item. The body data is written to the OpenSearch index |
|
Consumes
|
|
Path Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Updates an item with the provided data in the body. The item is updated in the OpenSearch index |
|
Consumes
|
|
Path Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Deletes a specific item from the OpenSearch index |
|
Consumes
|
|
Path Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
Deployment API
These are the deployment endpoints.
| Method | Endpoint |
|---|---|
|
|
Description Get a list of all deployment systems (= backend Connections of type 'deployment_system'). |
|
Returns The requested data as JSON HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get the diff between a source deployment system or snapshot and a target deployment system. |
|
Query Parameters
|
|
Returns The requested data as JSON. HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get the diff of deployment source and target settings provided in the body content. Body:
|
|
Returns The diff as JSON HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Deploys the body content to the target system. |
|
Consumes
|
|
Query Parameters
|
|
Returns The deployment processing instructions as a JSON file to download when the HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Processes the deployment instructions provided by the body content. |
|
Consumes
|
|
Query Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description To download specific bundles (JAR/WAR files) by their IDs as MIME multipart data. Body:
|
|
Consumes
|
|
Returns The bundles as MIME multipart data HTTP status code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description To download a specific bundle (JAR/WAR files) by its ID. |
|
Path Parameter
|
|
Returns The bundle as a data stream HTTP status code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Imports the bundles provided by multipart form data. curl example
|
|
Consumes
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Special endpoint to import a single bundle from ExtJS using multipart form data. |
|
Consumes
|
|
Returns ExtJS-compliant status information with the filename HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Deployment diffs can only be performed when both systems use the same model version. This endpoint converts the model configurations provided in the content body to the model version of this installation. |
|
Consumes
|
|
Returns The migrated module configurations as JSON HTTP status code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Copy an index from one deployment system to another. |
|
Path Parameter
|
|
Query Parameters
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get a list of OpenSearch indices. |
|
Returns the index information HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get some information about an index to deploy. |
|
Path Parameter
|
|
Returns The index information, including its settings and mapping HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Downloads the first block of data from the specified index. |
|
Path Parameter
|
|
Query Parameter
|
|
Returns the requested data HTTP status code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Downloads the subsequent block of data from the given index. |
|
Path Parameter
|
|
Returns the requested data HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description To release a scroll identifier that is no longer in use. This helps OpenSearch free up resources much faster. |
|
Path Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Prepares an index for upload. Creates it with the given settings and mapping. Body:
|
|
Consumes
|
|
Path Parameter
|
|
Query Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Populate an index with the uploaded data. Body:
|
|
Consumes
|
|
Path Parameter
|
|
Returns HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
Event API
These are the endpoints for BPC events.
| Method | Endpoint |
|---|---|
|
|
Description To send a new event, send a JSON message with the following structure:
Fields
|
|
Consumes
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
Flow API
These are the endpoints for communicating with Flow.
| Method | Endpoint | |
|---|---|---|
|
||
Description Perform an HTTP GET on the given flow instance. |
||
Path Parameter
|
||
Query Parameter
|
||
Returns The response from the called Flow system |
||
Required Access Rights A logged-in user or API key is required. |
||
|
||
Description Perform an HTTP POST on the given flow instance. |
||
Path Parameter
|
||
Query Parameter
|
||
Returns The response from the called Flow system |
||
Required Access Rights A logged-in user or API key is required. |
||
|
||
Description Perform an HTTP PUT on the given flow instance. |
||
Path Parameter
|
||
Query Parameter
|
||
Returns The response from the called Flow system |
||
Required Access Rights A logged-in user or API key is required. |
||
|
||
Description Perform an HTTP DELETE on the given flow instance. |
||
Path Parameter
|
||
Query Parameter
|
||
Returns The response from the called Flow system |
||
Required Access Rights A logged-in user or API key is required. |
Frontend Logging API
These are the frontend logging endpoints.
| Method | Endpoint |
|---|---|
|
|
Description Saves the logs provided in the body to the OpenSearch index |
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights A logged-in user or API key is required. |
HTTP Proxy API
These are the endpoints for proxying HTTP requests to other systems.
| Method | Endpoint | |
|---|---|---|
|
||
Description Perform an HTTP GET on the 'httpproxy' backend Connection. |
||
Path Parameter
|
||
Query Parameter
|
||
Returns The response from the called backend connection HTTP Status Code
|
||
Required Access Rights A logged-in user or API key is required. |
||
|
||
Description Perform an HTTP POST on the 'httpproxy' backend Connection. |
||
Path Parameter
|
||
Query Parameter
|
||
Returns The response from the called backend connection HTTP Status Code
|
||
Required Access Rights A logged-in user or API key is required. |
||
|
||
Description Perform an HTTP PUT on the 'httpproxy' backend Connection. |
||
Path Parameter
|
||
Query Parameter
|
||
Returns The response from the called backend connection HTTP Status Code
|
||
Required Access Rights A logged-in user or API key is required. |
||
|
||
Description Perform an HTTP DELETE on the 'httpproxy' backend Connection. |
||
Path Parameter
|
||
Query Parameter
|
||
Returns The response from the called backend connection HTTP Status Code
|
||
Required Access Rights A logged-in user or API key is required. |
Identity Management API
These are the identity management endpoints. Please note that not all functions are supported by all identity providers. If a function is not supported, a UnsupportedOperationException is thrown. All calls—except for the GET methods—are logged in the audit log.
| Method | Endpoint |
|---|---|
|
|
Description Get a list of all users as JSON. |
|
Returns The requested data as JSON. Example response
HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Add a user by providing the data as JSON in the body. Example body
|
|
Consumes
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Update a user by providing the data as JSON in the body. Example body
|
|
Consumes
|
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Update a user’s password. Example form
|
|
Path Parameter
|
|
Form Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Delete a user. |
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get all organizations as a JSON array. |
|
Returns The requested data. Example response
HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get all roles as a JSON array. |
|
Returns The requested data. Example response
HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get all rights as a JSON array. |
|
Returns The requested data. Example response
HTTP Status Code
Content-Type
|
|
Required Access Rights A logged-in user or API key is required. |
|
|
|
Description Get the organizations of a user as a JSON array. |
|
Path Parameter
|
|
Returns The requested data. Example response
HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Add an organization to a user by providing the data as JSON in the body. Example body
|
|
Consumes
|
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Delete a user’s organization. |
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get the roles of a user as a JSON array. |
|
Path Parameter
|
|
Returns The requested data. Example response
HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Add a role to a user by providing the data as JSON in the body. Example body
|
|
Consumes
|
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Delete a user’s role. |
|
Consumes
|
|
Path Parameters
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get a user’s rights as a JSON array. |
|
Path Parameter
|
|
Returns The requested data. Example response
HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Add a right to a user by providing the data as JSON in the body. Example body
|
|
Consumes
|
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Delete a user’s right. |
|
Consumes
|
|
Path Parameter
|
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get a user’s data. |
|
Path Parameter
|
|
Returns The requested data. Example response
HTTP Status Code
Content-Type
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
Internationalization API
These are the internationalization endpoints.
| Method | Endpoint |
|---|---|
|
|
Description Get the languages used by the translations. |
|
Query Parameter
|
|
Returns The languages as JSON. Example response when
Example response when
HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Get all supported languages. |
|
Query Parameter
|
|
Returns The languages as JSON. Example response when
Example response when
HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Forces a reload of the translations. |
|
Returns HTTP Status Code
|
|
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
|
|
|
Description Get all translations for a specific language. This is a collection of the translations found in all
modules/bundles and those from our custom translations setting |
|
Path Parameter
|
|
Query Parameter
|
|
Returns A JSON object containing the translations. The keys are sorted in ascending order. HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
|
|
|
Description Checks if the provided language is known to the backend. Returns the default/fallback language if not. |
|
Path Parameter
|
|
Returns The given language if valid, otherwise the default language. Example response
HTTP Status Code
Content-Type
|
|
Required Access Rights Can be used without a user session. |
Log Service API
These are the endpoints of the log service.
| Method | Endpoint | |||||||||
|---|---|---|---|---|---|---|---|---|---|---|
|
||||||||||
Description Get a compact overview of the available log service instances. Only the following data is returned for each instance:
|
||||||||||
Returns The log service instances as JSON. HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Get the current configuration of the log service instance. |
||||||||||
Path Parameter
|
||||||||||
Returns The requested configuration as JSON. HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Retrieves the data for a log service instance. |
||||||||||
Path Parameter
|
||||||||||
Query Parameter
|
||||||||||
Returns The requested data as JSON. HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Get the data of a log service entry with its child entries. |
||||||||||
Path Parameter
|
||||||||||
Query Parameter
|
||||||||||
Returns The requested data as JSON. HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Get the data of a log service child entry. |
||||||||||
Path Parameter
|
||||||||||
Returns The requested data as JSON. HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Writes the data provided in the body to OpenSearch and/or the database. For calls from IGUASU the following HTTP headers are used and their values written to the following 'externalReference' object fields of all 'parent' related documents:
|
||||||||||
Consumes
|
||||||||||
Path Parameter
|
||||||||||
Query Parameter
|
||||||||||
Returns HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Deletes log service entries and their child entries from OpenSearch and the database. Attention: When you use 'childQuery' and/or 'childFilter' only those children get deleted, not the parent itself. |
||||||||||
Path Parameter
|
||||||||||
Query Parameter
|
||||||||||
Returns HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Deletes log service child entries from OpenSearch and the database. |
||||||||||
Path Parameter
|
||||||||||
Returns HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Deletes log service entries and their child entries from OpenSearch by query. Deletion from database is not supported. |
||||||||||
Consumes
|
||||||||||
Path Parameter
|
||||||||||
Query Parameter
|
||||||||||
Returns HTTP Status Code
Content-Type
|
||||||||||
Required Access Rights The logged-in user or API key must have either the following role or permission.
|
||||||||||
|
||||||||||
Description Deletes only log service child entries from OpenSearch by query. Deletion from database is not supported. |
||||||||||
Consumes
|
||||||||||
Path Parameter
|
||||||||||
Query Parameter
|
|Method |Endpoint
1+a|Description
Get all configured loggers with their currently set log level.
1+a|Returns
The requested data as JSON
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
LOGGERS_ADMIN -
Right:
LOGGERS_LIST_ALL
1+a|Description
Get a list of valid log levels.
1+a|Returns
The requested data as JSON
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
LOGGERS_ADMIN -
Right:
LOGGERS_LIST_VALID_LEVELS
1+a|Description
Set the log level for a specific logger.
1+a|Form Parameters
logger-
the name of the logger for which to set the log level
level-
the log level to set. Such as INFO, WARN, ERROR, …
1+a|Returns
HTTP status code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
LOGGERS_ADMIN -
Right:
LOGGERS_SET_LEVEL
[#lookup_joins_api] == Lookup Joins API These are the lookup joins endpoints. [cols="10a,90a"] |
|Method |Endpoint
1+a|Description
Refresh the lookup joins data for all replication jobs and log services-related indexes.
1+a|Returns
HTTP Status Code
-
200: OK
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
LOOKUP_JOINS_ADMIN -
Right:
LOOKUP_JOINS_REFRESH_ALL
1+a|Description
Refresh the lookup joins data of an index associated with a replication job.
1+a|Path Parameter
replicationJobId-
the ID of the replication job
1+a|Returns
HTTP Status Code
-
200: OK
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
LOOKUP_JOINS_ADMIN -
Right:
LOOKUP_JOINS_REFRESH
1+a|Description
Refresh the lookup joins data of a log service-related index.
1+a|Path Parameter
logServiceId-
the ID of the log service
1+a|Returns
HTTP status code
-
200: OK
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
LOOKUP_JOINS_ADMIN -
Right:
LOOKUP_JOINS_REFRESH
1+a|Description
Clears the internally used lookup joins caches.
1+a|Returns
HTTP Status Code
-
200: OK
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
LOOKUP_JOINS_ADMIN -
Right:
LOOKUP_JOINS_CLEAR_CACHE
[#notification_api] == Notification API These are the notification endpoints. [cols="10a,90a"] |
|Method |Endpoint
1+a|Description
To add a notification, send a JSON message with the following structure:
{
"subject": "Replication problem",
"message": "The database 'postgresql' is not reachable",
"recipients": [ "bpcadmin" ],
"recipientsType": "role"
}
{
"priority": 10,
"subject": "API expires soon",
"message": "API Key API-39e889a expires soon. Please contact your administrator.",
"recipients": [ "bpcadmin" ],
"recipientsType": "role",
"icon": "fa-file-certificate",
"type": "link",
"typeSpecificData": {
"targetModule": "_core",
"route" : ["_core", "apiKeys", "api", "API-39e889a"]
}
}
Fields
id(optional)-
ID of the notification. A random UUID is set if not provided.
priority(optional)-
Delivery priority of the notification. Can be one of the following values: 0 (Silent), 5 (Toast), 10 (Popup). 5 is used if not provided.
subject(required)-
The subject of the notification.
message(optional)-
The message of the notification.
recipients(required)-
The recipients of the notification. Depends on the used
recipientsType. recipientsType(required)-
The recipient type of the notification. Can be one of the following values:
user,role, ororganisation. originator(optional)-
The originator of the notification. The login name of the user session is used if not specified.
icon(optional)-
The Font Awesome icon to be used when displaying the notification.
type(optional)-
The type of the notification. The type 'info' is used if not specified. Other options include 'warn', 'error', 'link', etc. Depending on the type, the notification is displayed accordingly in the GUI (see also Notification Types and Display in the Interface).
typeSpecificData(optional)-
Additional type-specific data for the notification.
1+a|Consumes
-
application/json
1+a|Returns
The added notification as JSON. Also contains the 'date' and 'version' fields, which are automatically set or updated.
HTTP Status Code
-
200: OK -
404: Required Service not found -
500: Unexpected backend error -
503: Maintenance mode is active
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
NOTIFICATION_ADMIN -
Right:
NOTIFICATION_ADD
1+a|Description
To update a notification, send a JSON message with the following structure:
{
"subject": "Replication problem",
"message": "The database 'postgresql' is not reachable",
"recipients": [ "bpcadmin" ],
"recipientsType": "role"
}
{
"priority": 10,
"subject": "API expires soon",
"message": "API Key API-39e889a expires soon. Please contact your administrator.",
"recipients": [ "bpcadmin" ],
"recipientsType": "role",
"icon": "fa-file-certificate",
"type": "link",
"typeSpecificData": {
"targetModule": "_core",
"route" : ["_core", "apiKeys", "api", "API-39e889a"]
}
}
Fields
priority(optional)-
Delivery priority of the notification. Can be one of the following values: 0 (Silent), 5 (Toast), 10 (Popup). 5 is used if not specified.
subject(required)-
The subject of the notification.
message(optional)-
The message of the notification.
recipients(required)-
The recipients of the notification. Depends on the used
recipientsType. recipientsType(required)-
The recipient type of the notification. Can be one of the following values:
user,roleororganisation. originator(optional)-
The originator of the notification. If not specified, the login name of the user session is used.
icon(optional)-
The Font Awesome icon to be used when displaying the notification.
type(optional)-
The type of the notification. The type 'info' is used if not specified. Other options include 'warn', 'error', 'link', etc. Depending on the type, the notification is displayed accordingly in the GUI (see also Notification Types and Display in the Interface).
typeSpecificData(optional)-
Additional type-specific data for the notification.
1+a|Consumes
-
application/json
1+a|Path Parameter
notificationId-
the ID of the notification to update
1+a|Returns
The updated notification as JSON. Also contains the 'date' and 'version' fields, which are automatically set or updated.
HTTP Status Code
-
200: OK -
404: Required Service not found -
500: Unexpected backend error -
503: Maintenance mode is active
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
NOTIFICATION_ADMIN -
Right:
NOTIFICATION_UPDATE
1+a|Description
Delete a specific notification.
1+a|Path Parameter
notificationId-
the ID of the notification to delete
1+a|Returns
The deleted notification as JSON.
HTTP Status Code
-
200: OK -
404: Required service was not found -
404: Requested notification was not found -
500: Unexpected backend error -
503: Maintenance mode is active
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
NOTIFICATION_ADMIN -
Right:
NOTIFICATION_DELETE
1+a|Description
Get the data of a notification.
1+a|Path Parameter
notificationId-
the ID of the notification for which to retrieve data
1+a|Returns
The data of the requested notification as JSON.
HTTP Status Code
-
200: OK -
404: Required Service was not found -
404: Requested notification was not found or no access rights -
500: Unexpected backend error -
503: Maintenance mode is active
Content-Type
-
application/json
1+a|Required Access Rights
A logged-in user or API key is required.
1+a|Description
Get the notification of the requesting user.
1+a|Query Parameters
start-
Paging start parameter. Default is
0. limit-
Number of notifications to retrieve. Default is
1000.
1+a|Returns
The user’s requested notifications as JSON.
HTTP Status Code
-
200: OK -
404: The requested service was not found -
500: Unexpected backend error -
503: Maintenance mode is active
Content-Type
-
application/json
1+a|Required Access Rights
A logged-in user or API key is required.
[#opensearch_api] == OpenSearch API These are the OpenSearch endpoints. [cols="10a,90a"] |
|Method |Endpoint
1+a|Description
Get a list of all OpenSearch indices.
1+a|Returns
The requested data as JSON
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
OPENSEARCH_ADMIN -
Right:
OPENSEARCH_LIST_INDICES
1+a|Description
Get a compact list of OpenSearch indices. Can be used, for example, in a combo box.
1+a|Returns
The requested data as JSON
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
A logged-in user or API key is required.
1+a|Description
Get the settings and mappings of an OpenSearch index.
1+a|Path Parameter
indexName-
the name of the index
1+a|Returns
The requested data as JSON
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
OPENSEARCH_ADMIN -
Right:
OPENSEARCH_GET_MAPPING
1+a|Description
Delete an OpenSearch index.
1+a|Path Parameter
indexName-
the name of the index to delete
1+a|Returns
HTTP Status Code
-
200: OK
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
OPENSEARCH_ADMIN -
Right:
OPENSEARCH_DELETE_INDEX
1+a|Description
Get information on what a reindex action would do with the index settings and mappings.
1+a|Path Parameter
indexName-
the name of the index
1+a|Query Parameter
copyIndexMapping-
trueto copy the index mapping; otherwise,false. The default istrue. copyMetaData-
trueto copy the metadata; otherwise,false. The default istrue.
1+a|Returns
The old and new index settings and mappings as JSON
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
OPENSEARCH_ADMIN -
Right:
OPENSEARCH_REINDEX
1+a|Description
Perform a reindex action.
1+a|Path Parameter
indexName-
the name of the index to reindex
1+a|Query Parameter
copyIndexMapping-
trueto copy the index mapping; otherwise,false. The default istrue. copyMetaData-
trueto copy the metadata; otherwise,false. The default istrue. deleteSourceIndexAfterwards-
trueto delete the source index afterward;falseto close it instead. The default isfalse.
1+a|Returns
HTTP Status Code
-
200: OK
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
OPENSEARCH_ADMIN -
Right:
OPENSEARCH_REINDEX
[#performance_measurement_api] == Performance Measurement API These are the performance measurement endpoints. [cols="10a,90a"] |
|Method |Endpoint
1+a|Description
Saves the measurements provided in the body to the OpenSearch index bpc-performance.
1+a|Path Parameter
sessionId-
the ID of the session
1+a|Returns
HTTP Status Code
-
204: No content
1+a|Required Access Rights
A logged-in user or API key is required.
[#replication_api] == Replication API These are the replication endpoints. [cols="10a,90a"] |
|Method |Endpoint
1+a|Description
Get the last update timestamp of a replication job.
1+a|Path Parameter
replicationJobId-
the ID of the replication job
1+a|Returns
The requested last update timestamp.
HTTP Status Code
-
200: OK
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
REPLICATION_ADMIN -
Right:
REPLICATION_GET_LAST_UPDATE_TIMESTAMP_ON_RESTART
1+a|Description
Restarts a replication job.
1+a|Path Parameter
replicationJobId-
the ID of the replication job
1+a|Returns
HTTP Status Code
-
200: OK
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
REPLICATION_ADMIN -
Right:
REPLICATION_JOB_RESTART
1+a|Description
Forced start of a replication job.
1+a|Path Parameter
replicationJobId-
the ID of the replication job
1+a|Returns
HTTP Status Code
-
200: OK
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
REPLICATION_ADMIN -
Right:
REPLICATION_JOB_FORCED_START
[#server_api]
== Server API
These are the BPC server endpoints. Please ensure that every BPC server in the cluster uses a unique UUID.
This is configured by setting ` [cols="10a,90a"] |
|Method |Endpoint
1+a|Description
Get the UUIDs of the BPC servers in the cluster.
1+a|Returns
The requested data as JSON.
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
SERVER_ADMIN -
Right:
SERVER_GET_UUIDS
1+a|Description
Get detailed information about a BPC server in the cluster.
1+a|Path Parameter
uuid-
the UUID of the BPC server for which to retrieve information
1+a|Returns
The requested data as JSON.
HTTP Status Code
-
200: OK -
404: Requested server not found
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Role:
SERVER_ADMIN -
Right:
SERVER_GET_INFO
[#status_api] == Status API These are the status endpoints. [cols="10a,90a"] |
|Method |Endpoint
1+a|Description
Get the status of the local BPC server.
1+a|Returns
Depending on the user session, more or less data is returned as JSON.
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
Can be used without a user session.
1+a|Description
Get the status of a remote BPC server.
1+a|Path Parameter
serverUUID-
the UUID of the BPC server for which to retrieve the status
1+a|Returns
The requested data as JSON.
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
Can be used without a user session.
1+a|Description
Get the following health information in a single call:
-
status of loaded bundles
-
maintenance mode status
-
OpenSearch status
1+a|Returns
HTTP Status Code
-
200: When all 3 health statuses are fine -
503: When not all 3 health statuses are fine
1+a|Required Access Rights
Can be used without a user session.
1+a|Description
Get the status of all loaded BPC modules/bundles.
1+a|Returns
HTTP Status Code
-
200: Karaf is running and none of the BPC modules are in the 'Resolved' or 'Failure' state -
503: At least one BPC module is in the 'Resolved' or 'Failure' state
1+a|Required Access Rights
Can be used without a user session.
1+a|Description
Get the maintenance mode status.
1+a|Returns
HTTP Status Code
-
200: BPC is not in maintenance mode -
503: BPC is in maintenance mode
1+a|Required Access Rights
Can be used without a user session.
1+a|Description
Get the OpenSearch status.
1+a|Returns
HTTP Status Code
-
200: OK -
503: No connection to OpenSearch -
503: No nodes available -
503: Cluster health status is 'red'
1+a|Required Access Rights
Can be used without a user session.
1+a|Description
Get a list of all sessions.
1+a|Returns
The requested data as JSON.
HTTP Status Code
-
200: OK
Content-Type
-
application/json
1+a|Required Access Rights
The logged-in user or API key must have either the following role or permission.
-
Right:
getSessionStatus
1+a|Description
To check if this is the BPC Leader server.
1+a|Returns
HTTP Status Code
-
200: BPC is the Leader server -
503: BPC is not the Leader server
1+a|Required Access Rights
Can be used without a user session.
[#storage_api] == Storage API These are the storage endpoints. [cols="10a,90a"] |
|Method |Endpoint
1+a|Description
Get store items from the OpenSearch index bpc-store-<storeId>.
Returns an empty response when the store does not exist.
1+a|Path Parameter
storeId-
the ID of the store from which to retrieve items
1+a|Query Parameter
timezoneOffset-
time zone offset, such as
GMT+2(optional). Used when a date field is accessed in thefilterwith a range operator such as "gt", "gte", "lt", "lte", ">", ">=", ",<,", ",<,=". UTC is the default.timezoneNameis used beforetimezoneOffsetif both are set. timezoneName-
timezone name like
Europe/Berlin(optional). Is used if a date field is accessed in thefilterwith a range operator like "gt", "gte", "lt", "lte", ">", ">=", ",<,", ",<,=". UTC is the default. <INLINE_CODE_12/> is used before <INLINE_CODE_13/> if both are set.<NL/><INLINE_CODE_14/>:: first record to be read (optional, default = 0). Default is <INLINE_CODE_15/>.<NL/><INLINE_CODE_16/>:: number of records to read (optional, default = 1000, max. 10,000). The default is <INLINE_CODE_17/>.<NL/><INLINE_CODE_18/>:: simple search (optional). Example: <INLINE_CODE_19/>. Additional information on the <URL_0>Lucene Query String Syntax</URL_0>.<NL/><INLINE_CODE_20/>:: complex filter format as used by the monitor endpoint (optional). Example: <INLINE_CODE_21/><NL/><INLINE_CODE_22/>:: specification of the field by which the entries should be sorted (optional). Format: fieldname\<PIPE/>[ASC\<PIPE/>DESC]. Example: <INLINE_CODE_23/>. Multiple sorting instructions can be specified, separated by commas.<NL/><NL/>1+a<PIPE/><BOLD><BOLD>Returns</BOLD></BOLD><NL/><NL/>The requested store items as JSON<NL/><NL/>HTTP Status Code<NL/><NL/>- <INLINE_CODE_24/> : OK<NL/>- <INLINE_CODE_25/> : OpenSearch Service not found<NL/>- <INLINE_CODE_26/> : The provided JSON could not be parsed<NL/>- <INLINE_CODE_27/> : Something went wrong while accessing OpenSearch<NL/><NL/>Content-Type<NL/><NL/>- <INLINE_CODE_28/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Required Access Rights</BOLD></BOLD><NL/><NL/><INCLUDE_0/><NL/><NL/><NL/>// ================================================================================================<NL/><NL/><BLOCK_TITLE/>5+<PIPE/> <ADMONITION_1> <INLINE_CODE_29/></ADMONITION_1><PIPE/> <INLINE_CODE_30/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Description</BOLD></BOLD><NL/><NL/>Retrieve a specific store item from the OpenSearch index <INLINE_CODE_31/>.<NL/><NL/>1+a<PIPE/><BOLD><BOLD>Path Parameter</BOLD></BOLD><NL/><NL/><INLINE_CODE_32/>:: the ID of the store to retrieve data from<NL/><INLINE_CODE_33/>:: the ID of the item<NL/><NL/>1+a<PIPE/><BOLD><BOLD>Returns</BOLD></BOLD><NL/><NL/>The requested store item as JSON<NL/><NL/>HTTP status code<NL/><NL/>- <INLINE_CODE_34/> : OK<NL/>- <INLINE_CODE_35/> : No access rights<NL/>- <INLINE_CODE_36/> : OpenSearch service not found<NL/>- <INLINE_CODE_37/> : Store not found<NL/>- <INLINE_CODE_38/> : Store item not found<NL/>- <INLINE_CODE_39/> : Something went wrong while accessing OpenSearch<NL/><NL/>Content-Type<NL/><NL/>- <INLINE_CODE_40/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Required Access Rights</BOLD></BOLD><NL/><NL/><INCLUDE_1/><NL/><NL/><NL/>// ================================================================================================<NL/><NL/><BLOCK_TITLE/>6+<PIPE/> <ADMONITION_2> <INLINE_CODE_41/></ADMONITION_2><PIPE/> <INLINE_CODE_42/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Description</BOLD></BOLD><NL/><NL/>Creates a new store item.<NL/>Writes the provided store item data to the OpenSearch index <INLINE_CODE_43/>.<NL/>It uses a new ID for the store item and sets this ID in the provided store item data as well.<NL/>Unrecognized elements at the root level are automatically saved to the 'customFields' field to avoid OpenSearch mapping issues.<NL/><NL/><BLOCK_TITLE/>Example of all fields<NL/><SOURCE_BLOCK_0/><NL/><NL/><BOLD><BOLD>Fields</BOLD></BOLD><NL/><NL/><INLINE_CODE_44/> (irrelevant) :: ID of the store item. A new random UUID is set instead.<NL/><INLINE_CODE_45/> (optional) :: The ID of the module to which the store item belongs. Can be used as a filter value when retrieving items.<NL/><INLINE_CODE_46/> (optional) :: The ID of the module instance to which the store item belongs. Can be used as a filter value when retrieving items.<NL/><INLINE_CODE_47/> (optional) :: The name of the store item (be creative). Can be used as a filter value when retrieving items.<NL/><INLINE_CODE_48/> (required) :: The actual value/content/data of the store item.<NL/><INLINE_CODE_49/> (optional) :: To mark the store item as a favorite. Defaults to false.<NL/><INLINE_CODE_50/> (required) :: The read restrictions. Define who can read this item. At least one of the subelements must be set.<NL/><INLINE_CODE_51/> (optional) :: Only this username has read access to this store item. When set, the other fields—'organizations', 'roles', and 'rights'—are not saved.<NL/><INLINE_CODE_52/> (optional) :: Anyone associated with one of these organizations has read access to this store item.<NL/><INLINE_CODE_53/> (optional) :: Anyone with one of these roles has read access to this store item.<NL/><INLINE_CODE_54/> (optional) :: Anyone with one of these rights has read access to this store item.<NL/><INLINE_CODE_55/> (required) :: The write restrictions. Define who can update and delete this item. At least one of the subelements must be set.<NL/><INLINE_CODE_56/> (optional) :: Only this username has write access to this store item. When set, the other fields—'organizations', 'roles', and 'rights'—are not saved.<NL/><INLINE_CODE_57/> (optional) :: Anyone associated with one of these organizations has write access to this store item.<NL/><INLINE_CODE_58/> (optional) :: Anyone with one of these roles has write access to this store item.<NL/><INLINE_CODE_59/> (optional) :: Anyone with one of these rights has write access to this store item.<NL/><INLINE_CODE_60/> (optional) :: Values that do not fit into the 'value' field.<NL/><NL/>1+a<PIPE/><BOLD><BOLD>Consumes</BOLD></BOLD><NL/><NL/>- <INLINE_CODE_61/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Path Parameter</BOLD></BOLD><NL/><NL/><INLINE_CODE_62/>:: the ID of the store<NL/><NL/>1+a<PIPE/><BOLD><BOLD>Returns</BOLD></BOLD><NL/><NL/>The ID of the created store item<NL/><NL/>HTTP Status Code<NL/><NL/>- <INLINE_CODE_63/> : OK<NL/>- <INLINE_CODE_64/> : OpenSearch service not found<NL/>- <INLINE_CODE_65/> : Store not found<NL/>- <INLINE_CODE_66/> : Mandatory fields missing<NL/>- <INLINE_CODE_67/> : Store could not be created<NL/>- <INLINE_CODE_68/> : Problem with the provided JSON<NL/>- <INLINE_CODE_69/> : Something went wrong while accessing OpenSearch<NL/><NL/>Content-Type<NL/><NL/>- <INLINE_CODE_70/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Required Access Rights</BOLD></BOLD><NL/><NL/><INCLUDE_2/><NL/><NL/><NL/>// ================================================================================================<NL/><NL/><BLOCK_TITLE/>6+<PIPE/> <ADMONITION_3> <INLINE_CODE_71/></ADMONITION_3><PIPE/> <INLINE_CODE_72/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Description</BOLD></BOLD><NL/><NL/>Creates or updates a store item.<NL/>Writes the store item data provided in the body to the OpenSearch index <INLINE_CODE_73/>.<NL/>An existing store item is updated, and a nonexistent one is created.<NL/>Unrecognized elements at the root level are automatically saved to the 'customFields' field to avoid OpenSearch mapping issues.<NL/><NL/><BLOCK_TITLE/>Example of all fields<NL/><SOURCE_BLOCK_1/><NL/><NL/><BOLD><BOLD>Fields</BOLD></BOLD><NL/><NL/><INLINE_CODE_74/> (irrelevant) :: ID of the store item. The path parameter is set in the given document instead.<NL/><INLINE_CODE_75/> (optional) :: The ID of the module to which the store item belongs. Can be used as a filter value when retrieving items.<NL/><INLINE_CODE_76/> (optional) :: The ID of the module instance to which the store item belongs. Can be used as a filter value when retrieving items.<NL/><INLINE_CODE_77/> (optional) :: The name of the store item (be creative). Can be used as a filter value when retrieving items.<NL/><INLINE_CODE_78/> (required) :: The actual value/content/data of the store item.<NL/><INLINE_CODE_79/> (optional) :: To mark the store item as a favorite. Defaults to false.<NL/><INLINE_CODE_80/> (required) :: The read restrictions. Define who can read this item. At least one of the subelements must be set.<NL/><INLINE_CODE_81/> (optional) :: Only this username has read access to this store item. When set, the other fields—'organizations', 'roles', and 'rights'—are not saved.<NL/><INLINE_CODE_82/> (optional) :: Anyone with one of these organizations has read access to this store item.<NL/><INLINE_CODE_83/> (optional) :: Anyone with one of these roles has read access to this store item.<NL/><INLINE_CODE_84/> (optional) :: Anyone with one of these rights has read access to this store item.<NL/><INLINE_CODE_85/> (required) :: The write restrictions. Define who can update and delete this item. At least one of the subelements must be set.<NL/><INLINE_CODE_86/> (optional) :: Only this username has write access to this store item. When set, the other fields—'organizations', 'roles', and 'rights'—are not saved.<NL/><INLINE_CODE_87/> (optional) :: Anyone with one of these organizations has write access to this store item.<NL/><INLINE_CODE_88/> (optional) :: Anyone with one of these roles has write access to this store item.<NL/><INLINE_CODE_89/> (optional) :: Anyone with one of these rights has write access to this store item.<NL/><INLINE_CODE_90/> (optional) :: Values that do not fit into the 'value' field.<NL/><NL/>1+a<PIPE/><BOLD><BOLD>Consumes</BOLD></BOLD><NL/><NL/>- <INLINE_CODE_91/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Path Parameter</BOLD></BOLD><NL/><NL/><INLINE_CODE_92/>:: the ID of the store<NL/><INLINE_CODE_93/>:: the ID of the item<NL/><NL/>1+a<PIPE/><BOLD><BOLD>Returns</BOLD></BOLD><NL/><NL/>HTTP Status Code<NL/><NL/>- <INLINE_CODE_94/> : OK<NL/>- <INLINE_CODE_95/> : Insufficient access rights to update the store item<NL/>- <INLINE_CODE_96/> : OpenSearch service not found<NL/>- <INLINE_CODE_97/> : Store not found<NL/>- <INLINE_CODE_98/> : Mandatory fields missing<NL/>- <INLINE_CODE_99/> : Store could not be created<NL/>- <INLINE_CODE_100/> : Problem with the provided JSON<NL/>- <INLINE_CODE_101/> : Something went wrong while accessing OpenSearch<NL/><NL/>Content-Type<NL/><NL/>- <INLINE_CODE_102/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Required Access Rights</BOLD></BOLD><NL/><NL/><INCLUDE_3/><NL/><NL/><NL/>// ================================================================================================<NL/><NL/><BLOCK_TITLE/>5+<PIPE/> <ADMONITION_4> <INLINE_CODE_103/></ADMONITION_4><PIPE/> <INLINE_CODE_104/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Description</BOLD></BOLD><NL/><NL/>Deletes a specific store item from the OpenSearch index <INLINE_CODE_105/>.<NL/><NL/>1+a<PIPE/><BOLD><BOLD>Path Parameter</BOLD></BOLD><NL/><NL/><INLINE_CODE_106/>:: the ID of the store<NL/><INLINE_CODE_107/>:: the ID of the item to delete<NL/><NL/>1+a<PIPE/><BOLD><BOLD>Returns</BOLD></BOLD><NL/><NL/>HTTP Status Code<NL/><NL/>- <INLINE_CODE_108/> : OK<NL/>- <INLINE_CODE_109/> : Insufficient access rights to delete the store item<NL/>- <INLINE_CODE_110/> : OpenSearch Service not found<NL/>- <INLINE_CODE_111/> : Store not found<NL/>- <INLINE_CODE_112/> : Store item not found<NL/>- <INLINE_CODE_113/> : Something went wrong while accessing OpenSearch<NL/><NL/>Content-Type<NL/><NL/>- <INLINE_CODE_114/><NL/><NL/>1+a<PIPE/><BOLD><BOLD>Required Access Rights</BOLD></BOLD><NL/><NL/><INCLUDE_4/><NL/><NL/><NL/><TABLE/><NL/>